DEBUG_DOMAINS = {
  "Parsing": False,
  "Formatting": False,
  "Construction": False,
  "Actions": False,
  "Conditions": False,
  "Understanding": False,
  "Binding": False,
  "Simulation": False,
  "ForcedExit": False,
}

LOGFILE = None

INDENTS = {
}

def domainactive(domain):
  return domain not in DEBUG_DOMAINS or DEBUG_DOMAINS[domain]

def activate():
  for d in DEBUG_DOMAINS:
    DEBUG_DOMAINS[d] = True

def set_log(logfile):
  global LOGFILE
  LOGFILE = open(logfile, 'w')

def indent(domain):
  global INDENTS
  if domainactive(domain):
    if domain in INDENTS:
      INDENTS[domain] += 2
    else:
      INDENTS[domain] = 2

def exdent(domain):
  global ind
  if domainactive(domain):
    if domain in INDENTS:
      INDENTS[domain] -= 2
    else:
      INDENTS[domain] = 0

def debug(domain, *args):
  global LOGFILE, INDENTS
  indent = ""
  if domain in INDENTS:
    indent = ' '*INDENTS[domain]
  line = "{indent}{content}".format(
    indent=indent,
    content=' '.join(str(a) for a in args)
  )
  head = str(domain)
  if domain not in DEBUG_DOMAINS:
    head = "INVALID DOMAIN '" + head + "'"
  line = head + ": " + line
  if domain not in DEBUG_DOMAINS or DEBUG_DOMAINS[domain]:
    if LOGFILE:
      LOGFILE.write(line + "\n")
    else:
      print(line)
